/**
 * machina - A library for creating powerful and flexible finite state machines. Loosely inspired by Erlang/OTP's gen_fsm behavior.
 * Author: Jim Cowart (http://ifandelse.com)
 * Version: v1.1.2
 * Url: http://machina-js.org/
 * License(s): MIT, GPL
 */
(function(t,e){"function"==typeof define&&define.amd?define(["lodash"],function(i){return e(i,t)}):"object"==typeof module&&module.exports?module.exports=e(require("lodash")):t.machina=e(t._,t)})(this,function(t,e,i){function n(){return{initialState:"uninitialized",eventListeners:{"*":[]},states:{},namespace:S.makeFsmNamespace(),useSafeEmit:!1,hierarchy:{},pendingDelegations:{}}}function s(){return{inputQueue:[],targetReplayState:"",state:i,priorState:i,priorAction:"",currentAction:"",currentActionArgs:i,inExitHandler:!1}}function a(t,e){for(var i=[],n=e||0;n<t.length;n++)i[n]=t[n];return i}function r(t){if(t){var e={};return"object"==typeof t?t.factory?e=t:e.factory=function(){return t}:"function"==typeof t&&(e.factory=t),e.instance=e.factory(),e}}function o(t,e){return e.on("*",function(e,i){switch(e){case"nohandler":i.ticket||i.delegated||i.namespace===t.namespace||(i.args[1].bubbling=!0),"_reset"!==i.inputType&&t.handle.apply(t,i.args);break;case"handling":var n=i.ticket;n&&t.pendingDelegations[n]&&delete t.pendingDelegations[n],t.emit(e,i);break;default:t.emit(e,i)}})}function c(){for(var t=[],e="0123456789abcdef",i=0;36>i;i++)t[i]=e.substr(Math.floor(16*Math.random()),1);return t[14]="4",t[19]=e.substr(3&t[19]|8,1),t[8]=t[13]=t[18]=t[23]="-",t.join("")}function u(e){t.extend(this,e),t.defaults(this,n()),this.initialize.apply(this,arguments),x.emit(v,this)}var l=[].slice,h="transition",p="handling",f="handled",d="nohandler",g="transition",m="invalidstate",y="deferred",v="newfsm",b=["states","initialState"],_=function(e,i){var n,s=this,a={},r=function(){};return n=e&&e.hasOwnProperty("constructor")?e.constructor:function(){var e=l.call(arguments,0);e[0]=e[0]||{};var i,n=e[0].states||{};i=t.merge(t.cloneDeep(a),{states:n}),i.initialState=e[0].initialState||this.initialState,t.extend(e[0],i),s.apply(this,e)},t.merge(n,s),r.prototype=s.prototype,n.prototype=new r,e&&(t.extend(n.prototype,e),t.merge(a,t.transform(e,function(t,e,i){-1!==b.indexOf(i)&&(t[i]=e)}))),i&&t.merge(n,i),n.prototype.constructor=n,n.__super__=s.prototype,n},S={makeFsmNamespace:function(){var t=0;return function(){return"fsm."+t++}}(),listenToChild:o,getLeaklessArgs:a,getDefaultOptions:n,getDefaultClientMeta:s,createUUID:c},A={emit:function(e){var i=a(arguments);this.eventListeners["*"]&&t.each(this.eventListeners["*"],function(t){if(this.useSafeEmit)try{t.apply(this,i)}catch(e){console&&"undefined"!=typeof console.log&&console.log(e.stack)}else t.apply(this,i)},this),this.eventListeners[e]&&t.each(this.eventListeners[e],function(t){if(this.useSafeEmit)try{t.apply(this,i.slice(1))}catch(e){console&&"undefined"!=typeof console.log&&console.log(e.stack)}else t.apply(this,i.slice(1))},this)},on:function(t,e){var i=this;return i.eventListeners=i.eventListeners||{"*":[]},i.eventListeners[t]||(i.eventListeners[t]=[]),i.eventListeners[t].push(e),{eventName:t,callback:e,off:function(){i.off(t,e)}}},off:function(e,i){this.eventListeners=this.eventListeners||{"*":[]},e?this.eventListeners[e]=i?t.without(this.eventListeners[e],i):[]:this.eventListeners={}}},E="__machina__";t.extend(u.prototype,{initialize:function(){},initClient:function(t){var e=this.initialState;if(!e)throw new Error("You must specify an initial state for this FSM");if(!this.states[e])throw new Error("The initial state specified does not exist in the states object.");this.transition(t,e)},ensureClientMeta:function(e){if("object"!=typeof e)throw new Error("An FSM client must be an object.");return e[E]=e[E]||{},e[E][this.namespace]||(e[E][this.namespace]=t.cloneDeep(S.getDefaultClientMeta()),this.initClient(e)),e[E][this.namespace]},buildEventPayload:function(e,i){return t.isPlainObject(i)?t.extend(i,{client:e,namespace:this.namespace}):{client:e,data:i||null,namespace:this.namespace}},getHandlerArgs:function(t,e){var i=t.slice(0),n=i[1];return"object"==typeof n&&i.splice(1,1,n.inputType),e?i:[i[0]].concat(i.slice(2))},handle:function(e,n){var s=n;if("undefined"==typeof n)throw new Error("The input argument passed to the FSM's handle method is undefined. Did you forget to pass the input name?");"string"==typeof n&&(s={inputType:n,delegated:!1,ticket:i});var r=this.ensureClientMeta(e),o=a(arguments);"object"!=typeof n&&o.splice(1,1,s),r.currentActionArgs=o.slice(1);var c,u,l,h,g,m=r.state,y=this.states[m],v=!1;if(!r.inExitHandler)if(l=y._child&&y._child.instance,!l||this.pendingDelegations[s.ticket]||s.bubbling){s.ticket&&this.pendingDelegations[s.ticket]&&delete this.pendingDelegations[s.ticket],c=y[s.inputType]?s.inputType:"*",v="*"===c,u=y[c]||this[c]||this["*"],g=r.state+"."+c,r.currentAction=g;var b=this.buildEventPayload(e,{inputType:s.inputType,delegated:s.delegated,ticket:s.ticket});u?(this.emit(p,b),"function"==typeof u?h=u.apply(this,this.getHandlerArgs(o,v)):(h=u,this.transition(e,u)),this.emit(f,b)):this.emit(d,t.extend({args:o},b)),r.priorAction=r.currentAction,r.currentAction=""}else s.ticket=s.ticket||S.createUUID(),s.delegated=!0,this.pendingDelegations[s.ticket]={delegatedTo:l.namespace},h=l.handle.apply(l,o);return h},transition:function(t,e){var i,n=this.ensureClientMeta(t),s=n.state,a=this.states[s],o=this.states[e];if(!n.inExitHandler&&e!==s){if(o){o._child&&(o._child=r(o._child),i=o._child&&o._child.instance),a&&a._onExit&&(n.inExitHandler=!0,a._onExit.call(this,t),n.inExitHandler=!1),a&&a._child&&a._child.instance&&this.hierarchy[a._child.instance.namespace]&&this.hierarchy[a._child.instance.namespace].off(),n.targetReplayState=e,n.priorState=s,n.state=e,i&&(this.hierarchy[i.namespace]=S.listenToChild(this,i));var c=this.buildEventPayload(t,{fromState:n.priorState,action:n.currentAction,toState:e});return this.emit(g,c),o._onEnter&&o._onEnter.call(this,t),i&&i.handle(t,"_reset"),void(n.targetReplayState===e&&this.processQueue(t,h))}this.emit(m,this.buildEventPayload(t,{state:n.state,attemptedState:e}))}},deferUntilTransition:function(t,e){var i=this.ensureClientMeta(t);if(i.currentActionArgs){var n={type:h,untilState:e,args:i.currentActionArgs};i.inputQueue.push(n);var s=this.buildEventPayload(t,{state:i.state,queuedArgs:n});this.emit(y,s)}},deferAndTransition:function(t,e){this.deferUntilTransition(t,e),this.transition(t,e)},processQueue:function(e){var i=this.ensureClientMeta(e),n=function(t){return!t.untilState||t.untilState===i.state},s=t.filter(i.inputQueue,n);i.inputQueue=t.difference(i.inputQueue,s),t.each(s,function(t){this.handle.apply(this,[e].concat(t.args))},this)},clearQueue:function(e,i){var n=this.ensureClientMeta(e);if(i){var s=function(t){return i?t.untilState!==i:!0};n.inputQueue=t.filter(n.inputQueue,s)}else n.inputQueue=[]},compositeState:function(t){var e=this.ensureClientMeta(t),i=e.state,n=this.states[i]._child&&this.states[i]._child.instance;return n&&(i+="."+n.compositeState(t)),i}},A),u.extend=_;var k={constructor:function(){u.apply(this,arguments),this.ensureClientMeta()},initClient:function(){var t=this.initialState;if(!t)throw new Error("You must specify an initial state for this FSM");if(!this.states[t])throw new Error("The initial state specified does not exist in the states object.");this.transition(t)},ensureClientMeta:function(){return this._stamped||(this._stamped=!0,t.defaults(this,t.cloneDeep(s())),this.initClient()),this},ensureClientArg:function(t){var e=t;return"object"!=typeof e[0]||"inputType"in e[0]||e[0]===this?("object"!=typeof e[0]||"object"==typeof e[0]&&"inputType"in e[0])&&e.unshift(this):e.splice(0,1,this),e},getHandlerArgs:function(t,e){var i=t,n=i[1];return"object"==typeof inputType&&i.splice(1,1,n.inputType),i.slice(e?1:2)},buildEventPayload:function(){var e=this.ensureClientArg(S.getLeaklessArgs(arguments)),i=e[1];return t.isPlainObject(i)?t.extend(i,{namespace:this.namespace}):{data:i||null,namespace:this.namespace}}};t.each(["handle","transition","deferUntilTransition","processQueue","clearQueue"],function(t){k[t]=function(){var e=this.ensureClientArg(S.getLeaklessArgs(arguments));return u.prototype[t].apply(this,e)}}),k=u.extend(k);var x=t.merge(A,{Fsm:k,BehavioralFsm:u,utils:S,eventListeners:{newFsm:[]}});return x});